#include <LSkybox.h>
#include <LAssetsManager.h>

using namespace std;

namespace engine
{


    LSkybox::LSkybox( const string& skyboxResId )
    {
        GLfloat _vertices[] =
        {
            -1.0f,  1.0f, -1.0f,
            -1.0f, -1.0f, -1.0f,
             1.0f, -1.0f, -1.0f,
             1.0f, -1.0f, -1.0f,
             1.0f,  1.0f, -1.0f,
            -1.0f,  1.0f, -1.0f,

            -1.0f, -1.0f,  1.0f,
            -1.0f, -1.0f, -1.0f,
            -1.0f,  1.0f, -1.0f,
            -1.0f,  1.0f, -1.0f,
            -1.0f,  1.0f,  1.0f,
            -1.0f, -1.0f,  1.0f,

             1.0f, -1.0f, -1.0f,
             1.0f, -1.0f,  1.0f,
             1.0f,  1.0f,  1.0f,
             1.0f,  1.0f,  1.0f,
             1.0f,  1.0f, -1.0f,
             1.0f, -1.0f, -1.0f,

            -1.0f, -1.0f,  1.0f,
            -1.0f,  1.0f,  1.0f,
             1.0f,  1.0f,  1.0f,
             1.0f,  1.0f,  1.0f,
             1.0f, -1.0f,  1.0f,
            -1.0f, -1.0f,  1.0f,

            -1.0f,  1.0f, -1.0f,
             1.0f,  1.0f, -1.0f,
             1.0f,  1.0f,  1.0f,
             1.0f,  1.0f,  1.0f,
            -1.0f,  1.0f,  1.0f,
            -1.0f,  1.0f, -1.0f,

            -1.0f, -1.0f, -1.0f,
            -1.0f, -1.0f,  1.0f,
             1.0f, -1.0f, -1.0f,
             1.0f, -1.0f, -1.0f,
            -1.0f, -1.0f,  1.0f,
             1.0f, -1.0f,  1.0f
        };

        auto _vBuffer = new LVertexBuffer();
        _vBuffer->setData( sizeof( GLfloat ) * 3 * 36,
                           3, _vertices );

        m_vertexArray = new LVertexArray();
        m_vertexArray->addBuffer( _vBuffer, 0 );

        m_cubeTextureRef = LAssetsManager::getCubeTexture( skyboxResId );
        // m_cubeTextureRef->log();
    }

    LSkybox::~LSkybox()
    {
        delete m_vertexArray;
    }

    void LSkybox::render()
    {
        m_cubeTextureRef->bind();
        m_vertexArray->bind();

        glDrawArrays( GL_TRIANGLES, 0, 36 );

        m_vertexArray->unbind();
        m_cubeTextureRef->unbind();
    }
}